﻿using System;
using System.Windows.Controls;
using System.Windows.Threading;

namespace MenuItemIsEnabledWorkaroundDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            // Start a timer to fire every second
            var timer = new DispatcherTimer();
            timer.Tick += new EventHandler(Timer_Tick);
            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Start();
        }

        void Timer_Tick(object sender, EventArgs e)
        {
            // Toggling IsEnabled hits the bug by default
            menuItemBug.IsEnabled = !menuItemBug.IsEnabled;

            // "Bouncing" the Template after toggling works around the issue
            menuItemBounce.IsEnabled = !menuItemBounce.IsEnabled;
            var template = menuItemBounce.Template;
            menuItemBounce.Template = null;
            menuItemBounce.Template = template;

            // Activating the workaround in XAML requires no code changes
            menuItemWorkaround.IsEnabled = !menuItemWorkaround.IsEnabled;
        }
    }
}
